package net.horizoncode.tickettest;

import lombok.Getter;
import net.horizoncode.tickettest.logging.Logger;
import net.horizoncode.tickettest.manager.TicketManager;

import java.io.File;
import java.util.stream.IntStream;

public class TicketTest {

  @Getter private static TicketTest instance;
  @Getter private final TicketManager ticketManager;
  @Getter private final Logger logger;

  public static void main(String[] args) {
    new TicketTest();
  }

  public TicketTest() {
    instance = this;
    this.logger = new Logger(new File("log"), true);
    this.ticketManager = TicketManager.builder().ticketLifespan(5000).maxTicketsExisting(2).build();

    IntStream.range(0, 10)
        .forEach(
            (value) ->
                getTicketManager()
                    .addTicket(
                        () -> {
                          getLogger().info("i expired, oof :c");
                        })
                    .use());

    while (true) {}
  }
}
